<script setup lang="ts" generic="T extends GeolocalisableItem & ListableItem">
    import { useDisplay } from 'vuetify/lib/framework.mjs'
    import { GeolocalisableItem } from '../entities/GeolocalisableItem'
    import SItemMapViewer from '@/shared/item/components/SItemMapViewer.vue'
    import SDraggableBottomSheet from '@/shared/containment/components/SDraggableBottomSheet.vue'
    import { watch } from 'vue'
    import SListItem from '@/shared/item/components/SListItem.vue'
    import { ListableItem } from '../entities/ListableItem'
    import { ListableItemList } from '../entities/ListableItemList'
    import { ButtonAction } from '@/shared/button/entities/ButtonAction'
    import SMultiFloatingActionButtons from '@/shared/button/components/SMultiFloatingActionButtons.vue'
    import {
        isDefined,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { ObjectPins } from '@/shared/entities/pins/ObjectPins'
    import { ElementWithId } from '@/shared/helpers/identifiable'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import { serviceOfferTrackingCategoryInjectionKey } from '@/shared/constants'
    import { ItemLists } from '@/interventionServiceOffer/composables/equipement/useItemLists'

    interface PaginatedListableItemList<T extends ListableItem>
        extends ListableItemList<T> {
        loadMore: () => Promise<void>
        hasMore: boolean | undefined
        isStale: boolean
        isLoading: boolean
        reload: () => void
    }

    interface Props {
        paginatedItemList?: PaginatedListableItemList<T>
        coordinatesItemList?: (GeolocalisableItem & ListableItem)[]
        noItemImage?: boolean
        isLoading?: boolean
        primaryActions?: ButtonAction[]
        primaryActionsIcon?: string
        selectedItemId?: string
        itemPins?: ObjectPins<ElementWithId>
    }

    const props = withDefaults(defineProps<Props>(), {
        paginatedItemList: undefined,
        coordinatesItemList: undefined,
        isLoading: false,
        noItemImage: false,
        primaryActions: () => [],
        primaryActionsIcon: 'mdi-plus',
        selectedItemId: undefined,
        itemPins: undefined,
    })
    defineEmits<{
        (e: 'closeDetailItem'): void
        (e: 'clickItem', item: ListableItem & GeolocalisableItem): void
        (e: 'doubleClickItem', item: ListableItem & GeolocalisableItem): void
    }>()

    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )

    const { mdAndUp } = useDisplay()

    // workaround d'un problème avec l'infinite scroll :
    // Si on finissait de charger une liste, done('empty') était appelé et il considérait que toutes la liste est terminée,
    // sauf que nous la liste change et peut re-ne-pas-etre-terminée
    // workaround chopé ici : https://github.com/vuetifyjs/vuetify/issues/19935#issuecomment-2251836919
    let infiniteScrollEvents:
        | ((value: 'ok' | 'empty' | 'error') => void)
        | undefined

    watch(
        () => props.paginatedItemList?.hasMore,
        (newHasmore, oldHasmore) => {
            if (newHasmore === oldHasmore) {
                return
            }
            if (isUndefined(infiniteScrollEvents)) {
                return
            }
            infiniteScrollEvents(
                props.paginatedItemList?.hasMore === false ? 'empty' : 'ok'
            )
        }
    )

    function pinItem(
        item: ListableItem & GeolocalisableItem,
        itemType: keyof ItemLists
    ) {
        if (isUndefined(props.itemPins)) {
            return
        }

        props.itemPins.addPin(item.getItemId())

        getAnalyticsProvider().sendEvent(
            serviceOfferTrackingCategory.value,
            'Epinglage de ' + itemType,
            item.getItemTitle()
        )
    }
</script>

<template>
    <template v-if="mdAndUp">
        <div class="h-100 w-100 d-flex" style="position: relative">
            <div
                id="items-list-desktop"
                data-cy="items-list-desktop"
                style="position: relative"
                class="d-flex flex-column align-start"
            >
                <v-progress-linear
                    v-if="isLoading === true"
                    data-cy="is-loading-item-list"
                    indeterminate
                    color="primary"
                    style="position: absolute; top: 0px; width: 100%"
                ></v-progress-linear>
                <div class="flex-grow-0 w-100">
                    <slot name="headers"></slot>
                    <div
                        v-if="paginatedItemList?.isStale"
                        class="text-center dashed-gray-bg cursor-pointer pa-1"
                        data-cy="cliquer-pour-rafraichir-btn"
                        @click="paginatedItemList.reload"
                    >
                        nouvelles données disponibles
                        <br />
                        <i class="text-grey">cliquer pour rafraichir</i>
                    </div>
                </div>
                <div
                    data-cy="items-list-desktop-items"
                    class="overflow-y-auto flex-shrink-1 w-100"
                >
                    <v-infinite-scroll
                        v-if="isDefined(paginatedItemList)"
                        class="overflow-hidden"
                        :items="paginatedItemList.items"
                        empty-text=""
                        mode="intersect"
                        margin="10px"
                        @load="
                            async ({ done }) => {
                                infiniteScrollEvents = done
                                await paginatedItemList?.loadMore()
                                if (paginatedItemList?.hasMore === false) {
                                    done('empty')
                                    return
                                }
                                done('ok')
                            }
                        "
                    >
                        <v-list
                            v-if="paginatedItemList?.items !== undefined"
                            lines="two"
                            class="pt-0"
                            style="
                                margin-top: -16px; /* fix espace bouffé par le v-infinite-scroll__side*/
                            "
                        >
                            <template
                                v-if="
                                    !paginatedItemList.isLoading &&
                                    paginatedItemList.items.length === 0
                                "
                            >
                                <p class="text-center pt-10 px-5">
                                    {{
                                        paginatedItemList.title === 'équipement'
                                            ? 'Aucun'
                                            : 'Aucune'
                                    }}
                                    {{ paginatedItemList.title }}
                                    {{
                                        paginatedItemList.title === 'équipement'
                                            ? 'trouvé'
                                            : 'trouvée'
                                    }}
                                    ...
                                </p>
                                <p class="pt-5 px-5">
                                    Modifiez vos filtres ou remontez dans le fil
                                    d'ariane.
                                </p>
                            </template>
                            <template
                                v-for="(
                                    item, itemIndex
                                ) in paginatedItemList.items"
                                :key="item.getItemId()"
                            >
                                <v-divider v-if="itemIndex > 0"></v-divider>
                                <s-list-item
                                    :active="
                                        selectedItemId === item.getItemId()
                                    "
                                    :item="item"
                                    :to="item.getItemRoute()"
                                    :item-height="paginatedItemList?.itemHeight"
                                    :pinable="isDefined(itemPins)"
                                    :is-pinned="
                                        itemPins?.pinnedIds.includes(
                                            item.getItemId()
                                        )
                                    "
                                    @pin="pinItem(item, 'équipements')"
                                    @unpin="
                                        itemPins?.removePin(item.getItemId())
                                    "
                                >
                                    <template #append-chip>
                                        <v-icon
                                            v-if="!item.hasLocation()"
                                            icon="mdi-map-marker-off-outline"
                                            size="small"
                                            color="grey"
                                        />
                                    </template>
                                </s-list-item>
                            </template>
                        </v-list>
                        <!-- On fait ça car il y a un bug avec le composant v-infinite-scroll qui laisse le loader quand la liste est vide -->
                        <template #loading>
                            <v-skeleton-loader
                                v-if="paginatedItemList.isLoading"
                                class="w-100"
                                type="list-item-avatar-two-line"
                            />
                        </template>
                    </v-infinite-scroll>
                </div>
            </div>
            <div style="flex-grow: 1; position: relative">
                <s-item-map-viewer
                    id="items-map-desktop"
                    style="width: 100%"
                    :items="coordinatesItemList"
                    :selected-item-id="selectedItemId"
                    @click-item="
                        (item) => {
                            $emit('clickItem', item)
                        }
                    "
                    @double-click-item="
                        (item) => {
                            $emit('doubleClickItem', item)
                        }
                    "
                >
                    <template #topOverlay>
                        <slot name="topOverlay"></slot>
                    </template>
                    <template #mainOverlay>
                        <div class="h-100 pb-2">
                            <v-card
                                v-if="isDefined($slots['item-details'])"
                                class="position-relative overflow-auto ml-2"
                                elevation="4"
                                style="
                                    max-width: 35rem;
                                    pointer-events: initial;
                                    max-height: 100%;
                                "
                            >
                                <v-btn
                                    icon="mdi-close"
                                    size="30"
                                    color="on-background"
                                    class="position-absolute top-0 right-0 mt-2 mr-2"
                                    style="z-index: 2"
                                    @click="$emit('closeDetailItem')"
                                />
                                <slot name="item-details"></slot>
                            </v-card>
                        </div>
                    </template>
                </s-item-map-viewer>
            </div>
            <s-multi-floating-action-buttons
                data-cy="primary-action-button"
                :icon="primaryActionsIcon"
                :button-actions="primaryActions"
                display="floating-absolute"
                floating-position="right"
            />
        </div>
    </template>
    <template v-else>
        <section style="position: relative; width: 100%">
            <s-item-map-viewer
                id="items-map-mobile"
                :items="coordinatesItemList"
                :selected-item-id="selectedItemId"
                @click-item="
                    (item) => {
                        $emit('clickItem', item)
                    }
                "
                @double-click-item="
                    (item) => {
                        $emit('doubleClickItem', item)
                    }
                "
            >
                <template #topOverlay>
                    <slot name="topOverlay"></slot>
                </template>
                <template #mainOverlay>
                    <s-draggable-bottom-sheet>
                        <template #fab>
                            <s-multi-floating-action-buttons
                                data-cy="primary-action-button"
                                :icon="primaryActionsIcon"
                                :button-actions="primaryActions"
                            />
                        </template>
                        <template #header>
                            <slot name="headers"></slot>

                            <v-progress-linear
                                v-if="isLoading === true"
                                data-cy="is-loading-item-list"
                                indeterminate
                                color="primary"
                            ></v-progress-linear>
                            <div
                                v-if="
                                    paginatedItemList?.isStale &&
                                    isUndefined($slots['item-details'])
                                "
                                class="flex-grow-0 w-100"
                            >
                                <div
                                    class="text-center dashed-gray-bg cursor-pointer pa-1"
                                    data-cy="cliquer-pour-rafraichir-btn"
                                    @click="paginatedItemList.reload"
                                >
                                    nouvelles données disponibles
                                    <br />
                                    <i class="text-grey"
                                        >cliquer pour rafraichir</i
                                    >
                                </div>
                            </div>
                        </template>
                        <div class="list-container">
                            <v-infinite-scroll
                                v-if="
                                    isDefined(paginatedItemList) &&
                                    isUndefined($slots['item-details'])
                                "
                                class="overflow-hidden"
                                :items="paginatedItemList.items"
                                empty-text=""
                                mode="intersect"
                                @load="
                                    async ({ done }) => {
                                        await paginatedItemList?.loadMore()
                                        if (
                                            paginatedItemList?.hasMore === false
                                        ) {
                                            done('empty')
                                            return
                                        }
                                        done('ok')
                                    }
                                "
                            >
                                <v-list
                                    v-if="
                                        paginatedItemList?.items !== undefined
                                    "
                                    lines="two"
                                    class="pt-0"
                                    style="
                                        margin-top: -16px; /* fix espace bouffé par le v-infinite-scroll__side*/
                                    "
                                >
                                    <template
                                        v-if="
                                            !paginatedItemList.isLoading &&
                                            paginatedItemList.items.length === 0
                                        "
                                    >
                                        <p class="text-center pt-10 px-5">
                                            {{
                                                paginatedItemList.title ===
                                                'équipement'
                                                    ? 'Aucun'
                                                    : 'Aucune'
                                            }}
                                            {{ paginatedItemList.title }}
                                            {{
                                                paginatedItemList.title ===
                                                'équipement'
                                                    ? 'trouvé'
                                                    : 'trouvée'
                                            }}
                                            ...
                                        </p>
                                        <p class="pt-5 px-5">
                                            Modifiez vos filtres ou remontez
                                            dans le fil d'ariane.
                                        </p>
                                    </template>
                                    <template
                                        v-for="(
                                            item, itemIndex
                                        ) in paginatedItemList.items"
                                        :key="item.getItemId()"
                                    >
                                        <v-divider
                                            v-if="itemIndex > 0"
                                        ></v-divider>
                                        <s-list-item
                                            :item="item"
                                            :to="item.getItemRoute()"
                                            :item-height="
                                                paginatedItemList?.itemHeight
                                            "
                                            :pinable="isDefined(itemPins)"
                                            :is-pinned="
                                                itemPins?.pinnedIds.includes(
                                                    item.getItemId()
                                                )
                                            "
                                            @pin="pinItem(item, 'équipements')"
                                            @unpin="
                                                itemPins?.removePin(
                                                    item.getItemId()
                                                )
                                            "
                                            ><template #append-chip>
                                                <v-icon
                                                    v-if="!item.hasLocation()"
                                                    small
                                                    color="grey"
                                                    >mdi-map-marker-off-outline</v-icon
                                                ></template
                                            ></s-list-item
                                        >
                                    </template>
                                </v-list>
                                <!-- On fait ça car il y a un bug avec le composant v-infinite-scroll qui laisse le loader quand la liste est vide -->
                                <template #loading>
                                    <v-skeleton-loader
                                        v-if="paginatedItemList.isLoading"
                                        class="w-100"
                                        type="list-item-avatar-two-line"
                                    />
                                </template>
                            </v-infinite-scroll>
                            <slot name="item-details"></slot>
                        </div>
                    </s-draggable-bottom-sheet>
                </template>
            </s-item-map-viewer>
        </section>
    </template>
</template>

<style scoped lang="scss">
    /* desktop */
    #items-list-desktop {
        background-color: #f9fbfd;
        max-width: 500px;
        width: 100%;
        z-index: 2;
        border-right: 1px solid #b8b9ba;
    }
    #items-map-desktop {
        width: 100%;
        height: 100%;
        z-index: 1;
    }
    /* mobile */
    #items-map-mobile {
        position: fixed;
        top: 64px;
        bottom: 0;
        left: 0;
        right: 0;
        z-index: 1;
    }
    .dashed-gray-bg {
        background-size: 20px 20px;
        background-repeat: repeat;
        background-color: #ddd;
        background-image: linear-gradient(
            -45deg,
            #eee 25%,
            transparent 25%,
            transparent 50%,
            #eee 50%,
            #eee 75%,
            transparent 75%,
            transparent
        );
    }
</style>
